Plant = Object:extend()

function Plant:new(x, y, originWidth, originHeight, maxwidth, maxheight, leafNum)
    self.width = originWidth
    self.height = originHeight
    self.x = x
    self.y = y
    self.maxWidth = maxwidth
    self.maxHeight = maxheight
    self.averageHeight = self.maxHeight / 16
    
    world:add(self, self.x, self.y, self.width, self.height)
    
    self.totalLeaf = 0
    self.leafNum = leafNum
    if self.leafNum == 2 then
        self.firstCheck = self.averageHeight * 10
        self.secondCheck = self.averageHeight * 8
    end
end

function Plant:update(dt)
    --[[local function checkOneFilter(item, other)
        if other.isLeaf then return 'cross' end
    end]]--
    
    local items, len = world:queryRect(self.width + self.x, self.averageHeight * 10, 30, 30)
    local count = world:countItems()
    for i = 1, count do
        local other = items[i].other
        if other.isLeaf == false and self.totalLeaf < self.leafNum then
            table.insert(listOfLeaf, Leaf(self.x + self.width, self.averageHeight * 10, 7.5, 4, 30, 16))
        end
        print("a")
    end
    if self.width < self.maxWidth then
        self.width = self.width + 0.05
        
    end
    if self.height < self.maxHeight then
        self.height = self.height + 0.05
        self.y = self.y - 0.05
    end
    world:update(self, self.x, self.y, self.width, self.height)
end

function Plant:draw()
    love.graphics.setColor(0.2, 0.8, 0.2)
    love.graphics.rectangle("fill", self.x, self.y, self.width, self.height)
end