WaterDrop = Object:extend()

function WaterDrop:new(x, y, width, height, xVel)
    self.x = x
    self.y = y
    self.width = width
    self.height = height
    self.speed = 2.5
    self.xVelocity = math.random(1, 3) * xVel
    self.yVelocity = math.random(2, 4) * -1
    world:add(self, self.x, self.y, self.width, self.height)
    self.isWater = true
    self.opacity = 1
end

function WaterDrop:update(dt)
    --[[
    self.rotation = self.rotation + 0.1
    self.x = self.x + math.cos(self.rotation) * self.speed
    self.y = self.y + math.sin(self.rotation) * self.speed]]--
    --[[if self.state == "goup" then
        self.y = self.y - 5
    end
    if self.state == "godown" then
        self.y = self.y + 5
    end
    if self.y < self.targetY then
        self.state = "godown"
        
    end]]--
    if self.yVelocity<10 then
      self.yVelocity = self.yVelocity+ 0.1
    end
    local waterFilter = function(item, other)
        if other.isBlock  then return 'touch'
        end
  -- else return nil
    end
    local goalX, goalY = self.x +self.xVelocity , self.y + self.yVelocity 
    local actualX, actualY, cols, len = world:move(self, goalX, goalY, waterFilter)
    self.x, self.y = actualX, actualY
    --self.y = self.y + self.yVelocity
    --self.x = self.x + self.xVelocity
    if self.opacity > 0 then
        self.opacity = self.opacity - 0.005
    end
    
    if self.opacity <= 0 then
        --print("bye!")
        self:boom()
    end
end

function WaterDrop:boom()
    for inum, wnow in ipairs(listOfWaters) do
	      if wnow == self then
            world:remove(self)
            table.remove(listOfWaters, inum) 
            break 
        end
    end
end

function WaterDrop:draw()
    love.graphics.setColor(0, 0, 255, self.opacity)
    love.graphics.rectangle("fill", self.x, self.y, self.width, self.height)
end