Leaf = Object:extend()

function Leaf:new(x, y, originWidth, originHeight, maxWidth, maxHeight)
    self.x = x
    self.y = y
    self.width = originWidth
    self.height = originHeight
    self.maxWidth = maxWidth
    self.maxHeight = maxHeight
    world:add(self, self.x, self.y, self.width, self.height)
    self.isLeaf = true
end

function Leaf:update(dt)
    if self.width < self.maxWidth then
        self.width = self.width + 0.05
        
    end
    if self.height < self.maxHeight then
        self.height = self.height + 0.05
        --self.y = self.y - 0.05
    end
    world:update(self, self.x, self.y, self.width, self.height)
    
end 

function Leaf:draw()
    love.graphics.setColor(0.2, 0.8, 0.2)
    love.graphics.rectangle("fill", self.x, self.y, self.width, self.height)
end