function love.load()
    Object = require "classic"
    require "player"
    player = Player(400, 300)
    
    require "block"
    listOfBlocks = {}
    table.insert(listOfBlocks, Block(300, 400, 500, 30))
    table.insert(listOfBlocks, Block(164, 100, 300, 30))
    
    bump = require 'bump'
    world = bump.newWorld(32)
    
    require"waterdrop"
    listOfWaters = {}
    --waterdr = WaterDrop(300, 300, 5, -90)
    
    
    world:add(player, player.x, player.y, player.width, player.height)
    world:add(listOfBlocks[1], listOfBlocks[1].x, listOfBlocks[1].y, listOfBlocks[1].width, listOfBlocks[1].height)
    world:add(listOfBlocks[2], listOfBlocks[2].x, listOfBlocks[2].y, listOfBlocks[2].width, listOfBlocks[2].height)
    
    require "effect"
    listOfEffect = {}
    
    require "leaf"
    listOfLeaf = {}
    
    
    require "plant"
    listOfPlant = {}
    table.insert(listOfPlant, Plant(listOfBlocks[1].x, listOfBlocks[1].y-20, 5, 20, 10, 80, 2))
    
    
    
end

function love.update(dt)
    --print(#listOfWaters)
    player:update(dt)
    for i3, v3 in ipairs(listOfWaters) do
        v3:update(dt)
    end
    for i4, v4 in ipairs(listOfEffect) do
        v4:update(dt)
    end
    for i6, v6 in ipairs(listOfPlant) do
        v6:update(dt)
    end
    for i8, v8 in ipairs(listOfLeaf) do
        v8:update(dt)
    end
end


function love.keypressed(key)
    if key == "w" then
        if player.isGrounded then
            player.vy = -400
            player.isJumping = true
            player.isGrounded = false
            player.doubleJumpReload = 10
            player.startCount = true
        end
    
        if player.canDoubleJump then
            player.vy = -400
            player.isJumping = true
            player.isGrounded = false
            player.canDoubleJump = false
            player.doubleJumpReload = 10
            player.startCount = false
        end
        player.canStomp = true
    end
    
    if key == "space" then
        if player.facing == "left" then
            table.insert(listOfWaters, WaterDrop(player.x+16, player.y+16, 10, 10, -1))
        elseif player.facing == "right" then
            table.insert(listOfWaters, WaterDrop(player.x+16, player.y+16, 10, 10,  1))
        end
      
    end
end

function love.draw()
    player:draw()
    for i, v in ipairs(listOfBlocks) do
        v:draw()
    end
    
    for i2, v2 in ipairs(listOfWaters) do
        v2:draw()
    end
    for i5, v5 in ipairs(listOfEffect) do
        v5:draw()
    end
    for i7, v7 in ipairs(listOfPlant) do
        v7:draw()
    end
    for i8, v8 in ipairs(listOfLeaf) do
        v8:draw()
    end
end